<?php

namespace Wp618\Login;

use function Wp618Com\aff9e7\is_admin_user;

if ( !defined( 'ABSPATH' ) ) exit;

//
class Action{
    private $app;
    private $start_time = 0;
    private $log_id = 0;

    //
    public function __construct(){
        $this->app = App::getInstance();

        add_action('wp_login', [$this, 'success_add_log']);
        add_action('wp_login_failed', [$this, 'failed_add_log']);
    }

    //
    public function failed_add_log($username){
        $this->add_log('登录失败', $username);
    }

    //
    public function success_add_log($username){
        $this->add_log('登录成功', $username);
    }

    public function add_log($type, $username){
        $this->start_time = microtime(true);

        $ip = $_SERVER['REMOTE_ADDR'];
        $lang = isset($_SERVER['HTTP_ACCEPT_LANGUAGE']) ? strip_tags($_SERVER['HTTP_ACCEPT_LANGUAGE']) : '-';
        $ua = isset($_SERVER['HTTP_USER_AGENT']) ? strip_tags($_SERVER['HTTP_USER_AGENT']) : '-';
        $ua = mb_substr($ua, 0, 255, 'utf-8');
        $referer = isset($_SERVER['HTTP_REFERER']) ? strip_tags($_SERVER['HTTP_REFERER']) : '-';
        $referer = mb_substr($referer, 0, 255, 'utf-8');

        $this->log_id = $this->app->visitor_model->insert([
            'ip' => $ip,
            'username' => mb_substr($username, 0, 127, 'utf-8'),
            'request_method' => strtolower($_SERVER['REQUEST_METHOD']),
            'lang' => $lang,
            'ua' => $ua,
            'url' => $_SERVER['REQUEST_URI'],
            'location' => '-',
            'page_type' => $type,
            'time_ms' => 0,
            'referer' => $referer,
            'user_id' => (int) get_current_user_id(),
        ]);

        $this->delete_more_data();
    }

    //
    public function update_log(){


    }

    //
    private function delete_more_data(){
        $max = get_config_value('general.max_count');
        if(empty($max)){
            $max = 10000;
        }

        $row_max = $this->app->visitor_model->get_one([
            'order' => 'id desc',
        ]);

        if(empty($row_max)){
            return false;
        }

        for($i = 0; $i < 10; $i++){
            $row_min = $this->app->visitor_model->get_one([
                'order' => 'id asc',
            ]);

            if(empty($row_min)){
                return false;
            }

            if(($row_max['id'] - $row_min['id']) >= $max){
                $this->app->visitor_model->delete(['id' => $row_min['id']]);
            }else{
                break;
            }
        }

        return true;
    }

}
